cordova.define("cordova-plugin-general.general", function(require, exports, module) {

var exec = require('cordova/exec');
var generalExport = {};

/**
 * navigator.general.showToast('my toast');
 */
generalExport.showToast = function (content) {
    exec(null, null, "GeneralPlugin", "showToast", [content]);
};

/**
 * navigator.general.showLoading('Loading...');
 */
generalExport.showLoading = function (loading) {
    exec(null, null, "GeneralPlugin", "showLoading", [loading]);
};

/**
 * navigator.general.dismissLoading();
 */
generalExport.dismissLoading = function (loading) {
    exec(null, null, "GeneralPlugin", "dismissLoading", [loading]);
};

/**
 * navigator.general.dismissLoading();
 *
 * code >= 100 return dialog id,the dialog id is used for dismiss dialog.
 * code == 0 user click dialog outside or click back.
 * code == 1 user click dialog positive button.
 * code == 2 user click dialog negative button.
 *
 * function onSuccess(code) {
 *     console.log("Show dialog success.")
 * }
 *
 * function onFail(message) {
 *     alert('Failed because: ' + message);
 * }
 */
generalExport.showDialog = function (title, content, positive, negative, successCallback, errorCallback) {
    exec(successCallback, errorCallback, "GeneralPlugin", "showDialog", [title,content,positive,negative]);
};

/**
 * navigator.general.dismissDialog(dialogId);
 *
 * function onSuccess() {
 *     console.log("Dismiss dialog success.")
 * }
 *
 * function onFail(message) {
 *     alert('Failed because: ' + message);
 * }
 */
generalExport.dismissDialog = function (dialogId, successCallback, errorCallback) {
    exec(successCallback, errorCallback, "GeneralPlugin", "dismissDialog", [dialogId]);
};

/**
 * navigator.general.getDeviceInfo();
 *
 * function onSuccess(deviceInfo) {
 *     console.log(deviceInfo)
 * }
 *
 */
generalExport.getDeviceInfo = function (successCallback) {
    exec(successCallback, null, "GeneralPlugin", "getDeviceInfo", []);
};

/**
 * navigator.general.router(params,onSuccess,onFail);
 *
 * function onSuccess() {
 *     console.log("")
 * }
 *
 * function onFail() {
 *
 * }
 */
generalExport.router = function (params,successCallback,failCallback) {
    exec(successCallback, failCallback, "GeneralPlugin", "router", [params.url,params.close]);
};

generalExport.faceAuthentication = function (params,successCallback, failCallback) {
    exec(successCallback, failCallback, "GeneralPlugin", "faceAuthentication", [params,successCallback, failCallback]);
};

/**
 * navigator.general.readPdf(params);
 {
	 url:"pdf链接",
	 title:"pdf标题(可选参数)"
 }
 */
generalExport.readPdf = function (params) {
    exec(null, null, "GeneralPlugin", "readPdf", [params.url,params.title]);
};

/**
 * navigator.general.download(params);
 * {
 *	 url:"下载链接",
 *	 type:"文件类型"
 * }
 */
generalExport.download = function (params) {
    exec(null, null, "GeneralPlugin", "download", [params.url,params.type]);
};

/**
 * 加载的h5页面必须要和APP是同一个域名下才能获取userInfo成功,否则都会返回失败
 *
 * navigator.general.getUserInfo(onSuccess,onFail);
 *
 * {
 *    "token":"很长一段",
 *    "appInfo":{
 *        "appVersion":"1.0",
 *        "deviceBrand":"HUAWEI",
 *        "deviceNo":"",
 *        "deviceType":"1",
 *        "imei":"863175032259935"
 *    },
 *    "appVersion":"1.0",
 *    "city":"",
 *    "currentClientFlag":"863175032259935",
 *    "deviceBrand":"HUAWEI",
 *    "deviceNo":"",
 *    "deviceType":"1",
 *    "email":"",
 *    "headimgurl":"",
 *    "id":"1187300061579579393",
 *    "imei":"863175032259935",
 *    "keyword":"",
 *    "mobile":"132****4592",
 *    "mobile1":"v2_eeb5b384b3ce8a75d4f33b75659ed929",
 *    "mobile2":"",
 *    "nickname":"132****4592",
 *    "openid":"",
 *    "province":"",
 *    "remark":"",
 *    "serverCode":"app",
 *    "sex":"",
 *    "unionid":"",
 *    "wxInfo":{
 *        "city":"",
 *        "headImage":"",
 *        "nick":"132****4592",
 *        "openid":"",
 *        "province":"",
 *        "sex":"",
 *        "unionid":""
 *    }
 * }
 *
 * function onSuccess(userInfo) {
 *     console.log(userInfo)
 * }
 *
 * 如果APP没有登录会回调 onFail 如果你这个页面必须要用户信息你可以执行 {navigator.app.exitApp()}
 * 该函数退出当前页面,如果要跳转到登录的话@see{#navigator.general.router()}
 *
 * function onFail() {
 *     navigator.general.router('登录action')
 *     navigator.app.exitApp();
 * }
 */
generalExport.getUserInfo = function (successCallback, failCallback) {
    exec(successCallback, failCallback, "GeneralPlugin", "getUserInfo", []);
};


/**
 * navigator.general.getUserInfo('mate data');
 *
 */
generalExport.sendMate = function (key, content) {
    exec(null, null, "GeneralPlugin", "sendMate", [key, content]);
};

/**
 * navigator.general.rightIcon('router');
 *
 */
//generalExport.rightIcon = function (params) {
//    exec(null, null, "GeneralPlugin", "rightIcon", [params.router]);
//};

/**
 * navigator.general.rightIcon({router : "wts://share?...", collect : "wts://collect?..."});
 */
generalExport.rightIcon = function (params,successCallback,failCallback) {
    exec(successCallback, failCallback, "GeneralPlugin", "rightIcon", [params.router, params.collect]);
};

/**
 * navigator.general.hideRightIcon();
 *
 */
generalExport.hideRightIcon = function () {
    exec(null, null, "GeneralPlugin", "hideRightIcon", []);
};

/**
 * navigator.general.logout();
 *
 */
generalExport.logout = function (successCallback, failCallback) {
    exec(successCallback, failCallback, "GeneralPlugin", "logout", []);
};

/**
 * navigator.general.uploadRecognition();
 *
 */
generalExport.uploadRecognition = function (successCallback, failCallback) {
    exec(successCallback, failCallback, "GeneralPlugin", "uploadRecognition", [successCallback, failCallback]);
};

/**
 * navigator.general.close();
 *
 */
generalExport.close = function () {
    exec(null, null, "GeneralPlugin", "close", []);
};

/**
 * 写法错误
 * @deprecated
 */
function getElementTop(element){
    if(element.parentElement) {
        return getElementTop(element.parentElement) + element.offsetTop;
    }
    return element.offsetTop;
}

function getAbsoluteTop(element){
	oTop = element.offsetTop;
	while(element.offsetParent != null){
		oParent = element.offsetParent;
		oTop += oParent.offsetTop;
		element = oParent;
	}
	return oTop;
}

/**
 * 写法错误
 * @deprecated
 */
function getElementLeft(element){
    if(element.parentElement) {
        return getElementLeft(element.parentElement) + element.offsetLeft;
    }
    return element.offsetLeft;
}

function getAbsoluteLeft(element){
	oLeft = element.offsetLeft;
	while(element.offsetParent != null){
		oParent = element.offsetParent;
		oLeft += oParent.offsetLeft;
		element = oParent;
	}
	return oLeft;
}

/**
 * navigator.general.playVideo({params.url});
 *
 */
generalExport.playVideo = function (params) {
    var img = params.imgDom;
    var rect = null;
    if(img){
        var offsetLeft = getAbsoluteLeft(img);
        var offsetTop = getAbsoluteTop(img);
        rect = {left:offsetLeft,
                top:offsetTop,
                right:offsetLeft + img.width,
                bottom:offsetTop + img.height};
    }
    exec(null, null, "GeneralPlugin", "playVideo", [params.url,params.thumb,rect,document.body.clientWidth]);
};

/**
 * navigator.general.showGallery();
 *
 */
generalExport.showGallery = function (index,imgs) {
    var urls  = new Array();
    var rects = new Array();
    for(var i = 0;i< imgs.length;i++){
        var img = imgs[i];
        urls[i] = img.src;
        var offsetLeft = getAbsoluteLeft(img);
        var offsetTop = getAbsoluteTop(img);
        rects[i] = {left:offsetLeft,
                    top:offsetTop,
                    right:offsetLeft + img.width,
                    bottom:offsetTop + img.height};
    }
    exec(null, null, "GeneralPlugin", "showGallery", [index,urls,rects,document.body.clientWidth]);
};

module.exports = generalExport;

});