cordova.define("cordova-plugin-wechat.wechat", function(require, exports, module) {

var exec = require('cordova/exec');
var wechatExport = {};

/**
* navigator.wechat.isWXAppInstalled();
* 微信是否安装（包含微信版本是否支持）
*/
wechatExport.isWXAppInstalled = function (successCallback, errorCallback) {
    exec(successCallback, errorCallback, "WechatPlugin", "isWXAppInstalled", []);
};


wechatExport.bindWeChat = function (successCallback, errorCallback) {
    exec(successCallback, errorCallback, "WechatPlugin", "bindWeChat", []);
};

/**
 * navigator.wechat.pay(params, onSuccess, onFail);
 *
 * code 订单号(不要以我们这边返回的为准)
 * function onSuccess(code) {
 *     console.log("Show dialog success.")
 * }
 *
 * message 失败原因
 * function onFail(message) {
 *     alert('Failed because: ' + message);
 * }
 */
wechatExport.pay = function (params, successCallback, errorCallback) {
    exec(successCallback, errorCallback, "WechatPlugin", "pay",  [params.appid, params.partnerid, params.prepayid, params.package, params.timestamp, params.sign, params.noncestr]);
};

/**
 * navigator.wechat.openMiniProgram(params);
 *
 * function onSuccess() {
 *     console.log("Show dialog success.")
 * }
 *
 * message 失败原因
 * function onFail(message) {
 *     alert('Failed because: ' + message);
 * }
 */
wechatExport.openMiniProgram = function (params, successCallback, errorCallback) {
    exec(successCallback, errorCallback, "WechatPlugin", "openMiniProgram", [params.userName, params.path, params.miniProgramType]);
};

/**
 * scene : WXSceneSession \ WXSceneTimeline
 * type : WX \ XCX \ IMG
 *
 * navigator.wechat.share(params);
 *
 * function onSuccess() {
 *     console.log("Show dialog success.")
 * }
 *
 * message 失败原因
 * function onFail(message) {
 *     alert('Failed because: ' + message);
 * }
 */
wechatExport.share = function (params) {
    exec(successCallback, errorCallback, "WechatPlugin", "share", [params.type, params.link, params.title, params.content, params.logo, params.scene, params.userName, params.path]);
};

/**
 * 该方法不可用,如果要登录{@see General.js}
 * navigator.wechat.authLogin();
 *
 */
wechatExport.authLogin = function () {
    exec(null, null, "WechatPlugin", "authLogin", []);
};

module.exports = wechatExport;

});